## gatk-bwamem 1.0.4%2Bdfsg2

=== Makefile ===
CC=			gcc
#CC=			clang --analyze
CFLAGS=		-g -Wall -Wno-unused-function -O2
WRAP_MALLOC=-DUSE_MALLOC_WRAPPERS
AR=			ar
DFLAGS=		-DHAVE_PTHREAD $(WRAP_MALLOC)
LOBJS=		utils.o kthread.o kstring.o ksw.o bwt.o bntseq.o bwa.o bwamem.o bwamem_pair.o bwamem_extra.o malloc_wrap.o
AOBJS=		rope.o rle.o bwashm.o bwase.o bwaseqio.o bwtgap.o bwtaln.o bamlite.o \
			is.o bwtindex.o bwape.o kopen.o pemerge.o maxk.o \
			bwtsw2_core.o bwtsw2_main.o bwtsw2_aux.o bwt_lite.o \
			bwtsw2_chain.o fastmap.o bwtsw2_pair.o
PROG=		bwa
INCLUDES=	
LIBS=		-lm -lz -lpthread
SUBDIRS=	.

ifeq ($(shell uname -s),Linux)
	LIBS += -lrt
endif

.SUFFIXES:.c .o .cc

.c.o:
		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $< -o $@

all:$(PROG)

bwa:libbwa.a $(AOBJS) main.o
		$(CC) $(CFLAGS) $(DFLAGS) $(AOBJS) main.o -o $@ -L. -lbwa $(LIBS)

bwamem-lite:libbwa.a example.o
		$(CC) $(CFLAGS) $(DFLAGS) example.o -o $@ -L. -lbwa $(LIBS)

libbwa.a:$(LOBJS)
		$(AR) -csru $@ $(LOBJS)

clean:
		rm -f gmon.out *.o a.out $(PROG) *~ *.a

depend:
	( LC_ALL=C ; export LC_ALL; makedepend -Y -- $(CFLAGS) $(DFLAGS) -- *.c )

# DO NOT DELETE THIS LINE -- make depend depends on it.

QSufSort.o: QSufSort.h
bamlite.o: bamlite.h malloc_wrap.h
bntseq.o: bntseq.h utils.h kseq.h malloc_wrap.h khash.h
bwa.o: bntseq.h bwa.h bwt.h ksw.h utils.h kstring.h malloc_wrap.h kvec.h
bwa.o: kseq.h
bwamem.o: kstring.h malloc_wrap.h bwamem.h bwt.h bntseq.h bwa.h ksw.h kvec.h
bwamem.o: ksort.h utils.h kbtree.h
bwamem_extra.o: bwa.h bntseq.h bwt.h bwamem.h kstring.h malloc_wrap.h
bwamem_pair.o: kstring.h malloc_wrap.h bwamem.h bwt.h bntseq.h bwa.h kvec.h
bwamem_pair.o: utils.h ksw.h
bwape.o: bwtaln.h bwt.h kvec.h malloc_wrap.h bntseq.h utils.h bwase.h bwa.h
bwape.o: ksw.h khash.h
bwase.o: bwase.h bntseq.h bwt.h bwtaln.h utils.h kstring.h malloc_wrap.h
bwase.o: bwa.h ksw.h
bwaseqio.o: bwtaln.h bwt.h utils.h bamlite.h malloc_wrap.h kseq.h
bwashm.o: bwa.h bntseq.h bwt.h
bwt.o: utils.h bwt.h kvec.h malloc_wrap.h
bwt_lite.o: bwt_lite.h malloc_wrap.h
bwtaln.o: bwtaln.h bwt.h bwtgap.h utils.h bwa.h bntseq.h malloc_wrap.h
bwtgap.o: bwtgap.h bwt.h bwtaln.h malloc_wrap.h
bwtindex.o: bntseq.h bwa.h bwt.h utils.h rle.h rope.h malloc_wrap.h
bwtsw2_aux.o: bntseq.h bwt_lite.h utils.h bwtsw2.h bwt.h kstring.h
bwtsw2_aux.o: malloc_wrap.h bwa.h ksw.h kseq.h ksort.h
bwtsw2_chain.o: bwtsw2.h bntseq.h bwt_lite.h bwt.h malloc_wrap.h ksort.h
bwtsw2_core.o: bwt_lite.h bwtsw2.h bntseq.h bwt.h kvec.h malloc_wrap.h
bwtsw2_core.o: khash.h ksort.h
bwtsw2_main.o: bwt.h bwtsw2.h bntseq.h bwt_lite.h utils.h bwa.h
bwtsw2_pair.o: utils.h bwt.h bntseq.h bwtsw2.h bwt_lite.h kstring.h
bwtsw2_pair.o: malloc_wrap.h ksw.h
example.o: bwamem.h bwt.h bntseq.h bwa.h kseq.h malloc_wrap.h
fastmap.o: bwa.h bntseq.h bwt.h bwamem.h kvec.h malloc_wrap.h utils.h kseq.h
is.o: malloc_wrap.h
kopen.o: malloc_wrap.h
kstring.o: kstring.h malloc_wrap.h
ksw.o: ksw.h malloc_wrap.h
main.o: kstring.h malloc_wrap.h utils.h
malloc_wrap.o: malloc_wrap.h
maxk.o: bwa.h bntseq.h bwt.h bwamem.h kseq.h malloc_wrap.h
pemerge.o: ksw.h kseq.h malloc_wrap.h kstring.h bwa.h bntseq.h bwt.h utils.h
rle.o: rle.h
rope.o: rle.h rope.h
utils.o: utils.h ksort.h malloc_wrap.h kseq.h

## gatk-bwamem 1.0.4%2Bdfsg3

=== debian/watch ===
Version: 5

Source: https://github.com/broadinstitute/gatk-bwamem-jni/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Compression: xz
Dversionmangle: auto
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Repack: yes
Repacksuffix: +dfsg

Component: bwa-apache2
Source: https://github.com/lh3/bwa
Matching-Pattern: heads/Apache2
Mode: git
Pgpmode: none
Version-Schema: ignore

## gatk-bwamem 1.0.4+dfsg2

=== src/main/c/Makefile ===
ifeq ($(JAVA_HOME),)
$(error $$(JAVA_HOME) is not defined)
endif

JNI_INCLUDE_DIRS=$(addprefix -I,$(shell find $(JAVA_HOME)/include -type d))
CFLAGS=-ggdb -O2 -Wall -fPIC $(JNI_INCLUDE_DIRS)
CC=gcc

#OS-dependent extension lookup
UNAME := $(shell uname)
ifeq ($(UNAME),Darwin)
LIB_EXT=Darwin.dylib
else
LIB_EXT=Linux.so
endif

BWA_MEM_COMMIT=cb950614ce7217788780b9a8d445c64cd4d8f62e
JNI_BASE_NAME=org_broadinstitute_hellbender_utils_bwa_BwaMemIndex

all: libbwa.$(LIB_EXT)

libbwa.$(LIB_EXT): $(JNI_BASE_NAME).o jnibwa.o bwa/libbwa.a
	$(CC) -ggdb -dynamiclib -shared -o $@ $^ -lm -lz -lpthread

bwa:
	git clone https://github.com/lh3/bwa && cd bwa && git checkout $(BWA_MEM_COMMIT) && echo '#define BWA_COMMIT "'$(BWA_MEM_COMMIT)'"' > bwa_commit.h
	sed -i.bak -e's/\(LOBJS=.*\)/\1 bwtindex.o rle.o rope.o bwt.o is.o/g' bwa/Makefile

bwa/libbwa.a: bwa
	$(MAKE) CFLAGS="$(CFLAGS)" -C bwa libbwa.a

$(JNI_BASE_NAME).o: $(JNI_BASE_NAME).c jnibwa.h bwa

jnibwa.o: jnibwa.c jnibwa.h bwa

clean:
	rm -rf bwa *.o *.$(LIB_EXT)

.PHONY: all clean

=== debian/changelog ===
gatk-bwamem (1.0.4+dfsg2-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:41:59 +0200

gatk-bwamem (1.0.4+dfsg2-2) unstable; urgency=medium

  * Source-only upload to unstable

 -- Pierre Gruet <pgt@debian.org>  Sat, 23 Jul 2022 07:12:52 +0200

gatk-bwamem (1.0.4+dfsg2-1) unstable; urgency=medium

  * Initial release (Closes: #1014344)

 -- Pierre Gruet <pgt@debian.org>  Wed, 06 Jul 2022 12:28:41 +0200

=== debian/control ===
Source: gatk-bwamem
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               default-jdk-headless,
               gradle-debian-helper,
               libsimde-dev,
               maven-repo-helper,
               testng <!nocheck>,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/gatk-bwamem
Vcs-Git: https://salsa.debian.org/med-team/gatk-bwamem.git
Homepage: https://github.com/broadinstitute/gatk-bwamem-jni/
Rules-Requires-Root: no

Package: libgatk-bwamem-java
Architecture: all
Depends: libgatk-bwamem-jni (>= ${source:Version}),
         libgatk-bwamem-jni (<< ${source:Version}.1~),
         ${java:Depends},
         ${misc:Depends}
Suggests: bwa
Description: interface to call Heng Li's bwa mem aligner from Java code
 BWA (Burrows-Wheeler Aligner) is a software package for mapping low-divergent
 sequences against a large reference genome, such as the human genome. It is
 written in C.
 .
 gatk-bwamem provides a Java library and a shared library to allow one to use
 BWA from Java code.
 .
 This package contains the Java library.

Package: libgatk-bwamem-jni
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: interface to call Heng Li's bwa mem aligner from Java code (jni)
 BWA (Burrows-Wheeler Aligner) is a software package for mapping low-divergent
 sequences against a large reference genome, such as the human genome. It is
 written in C.
 .
 gatk-bwamem provides a Java library and a shared library to allow one to use
 BWA from Java code.
 .
 This package contains the native library.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export JAVA_HOME  := /usr/lib/jvm/default-java

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with maven_repo_helper

override_dh_auto_clean:
	dh_auto_clean
	if [ -e src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c.save ]; then \
	        mv src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c.save src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c; \
	fi
	-rm src/test/resources/ref.fa.img
	# Cleaning the C part
	cd src/main/c/ && make clean
	-rm -rf src/main/c/bwaComponent
	# Replacing the modified build.gradle file having a version number by the original one.
	if [ -e build.gradle.old ]; then mv build.gradle.old build.gradle; fi

override_dh_auto_configure:
	# Putting the version in the JNI file so that is can output version information.
	cp src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c.save
	sed -i "s/BWA_COMMIT/\"$(DEB_VERSION)\"/" src/main/c/org_broadinstitute_hellbender_utils_bwa_BwaMemIndex.c
	# Copying the component sources to src/main/c for the JNI build
	mkdir -p src/main/c/bwaComponent/
	cp -a bwa-apache2/* src/main/c/bwaComponent/
	# Adding a version number in the build.gradle file.
	cp build.gradle build.gradle.old
	sed -i "s/\(^group.*\)/\1\nversion = '$(DEB_VERSION_UPSTREAM)'/ ; s/\+dfsg[[:digit:]]*//" build.gradle
	dh_auto_configure

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# The shared lib should be looked for in its build directory.
	LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$$(readlink -f src/main/c)" dh_auto_test
endif

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      repack,repacksuffix=+dfsg,compression=xz,dversionmangle=auto" \
 https://github.com/broadinstitute/gatk-bwamem-jni/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

 opts="component=bwa-apache2, \
       mode=git, pgpmode=none" \
  https://github.com/lh3/bwa heads/Apache2 ignore

## gatk-bwamem 1.0.4+dfsg3

=== Makefile ===
--- 
+++ 
@@ -17,19 +17,22 @@
 ifeq ($(shell uname -s),Linux)
 	LIBS += -lrt
 endif
+ifeq ($(shell uname -s),GNU/kFreeBSD)
+	LIBS += -lrt
+endif
 
 .SUFFIXES:.c .o .cc
 
 .c.o:
-		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $< -o $@
+		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $(CPPFLAGS) $< -o $@
 
 all:$(PROG)
 
 bwa:libbwa.a $(AOBJS) main.o
-		$(CC) $(CFLAGS) $(DFLAGS) $(AOBJS) main.o -o $@ -L. -lbwa $(LIBS)
+		$(CC) $(CFLAGS) $(LDFLAGS) $(AOBJS) main.o -o $@ -L. -lbwa $(LIBS)
 
 bwamem-lite:libbwa.a example.o
-		$(CC) $(CFLAGS) $(DFLAGS) example.o -o $@ -L. -lbwa $(LIBS)
+		$(CC) $(CFLAGS) $(LDFLAGS) example.o -o $@ -L. -lbwa $(LIBS)
 
 libbwa.a:$(LOBJS)
 		$(AR) -csru $@ $(LOBJS)
@@ -38,7 +41,7 @@
 		rm -f gmon.out *.o a.out $(PROG) *~ *.a
 
 depend:
-	( LC_ALL=C ; export LC_ALL; makedepend -Y -- $(CFLAGS) $(DFLAGS) -- *.c )
+	( LC_ALL=C ; export LC_ALL; makedepend -Y -- $(CFLAGS) $(DFLAGS) $(CPPFLAGS) -- *.c )
 
 # DO NOT DELETE THIS LINE -- make depend depends on it.
 
@@ -76,7 +79,7 @@
 is.o: malloc_wrap.h
 kopen.o: malloc_wrap.h
 kstring.o: kstring.h malloc_wrap.h
-ksw.o: ksw.h malloc_wrap.h
+ksw.o: ksw.h neon_sse.h scalar_sse.h malloc_wrap.h
 main.o: kstring.h malloc_wrap.h utils.h
 malloc_wrap.o: malloc_wrap.h
 maxk.o: bwa.h bntseq.h bwt.h bwamem.h kseq.h malloc_wrap.h

=== debian/changelog ===
gatk-bwamem (1.0.4+dfsg3-1) unstable; urgency=medium

  * New upstream version 1.0.4+dfsg3:
    - Only the bwa part was updated
  * Refreshing patches
  * Raising Standards version to 4.7.2 (no change)
  * Adding a --debug flag to circumvent problem with gradle output
    Closes: #1096676
  * Fixing syntax in header of patch for freebsd
  * Rewriting d/watch with version 5

 -- Pierre Gruet <pgt@debian.org>  Sat, 13 Dec 2025 15:00:25 +0100

gatk-bwamem (1.0.4+dfsg2-3) unstable; urgency=medium

  * Team upload.
  * d/rules: make sure the openmp-simd compiler flag is used.
  * d/patches/hardening: improve with the help of blhc.
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 24 Mar 2024 17:03:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gatk-bwamem
 Section: java
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Pierre Gruet <pgt@debian.org>
 Build-Depends: debhelper-compat (= 13),
                default-jdk-headless,
@@ -11,7 +10,7 @@
                maven-repo-helper,
                testng <!nocheck>,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/gatk-bwamem
 Vcs-Git: https://salsa.debian.org/med-team/gatk-bwamem.git
 Homepage: https://github.com/broadinstitute/gatk-bwamem-jni/

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # DH_VERBOSE := 1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 
@@ -39,6 +41,7 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	# The shared lib should be looked for in its build directory.
-	LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$$(readlink -f src/main/c)" dh_auto_test
+	# The shared lib should be looked for in its build directory. Without the
+	# --debug flag, the build mysteriously fails, see Debian bug #1096676.
+	LD_LIBRARY_PATH="$$LD_LIBRARY_PATH:$$(readlink -f src/main/c)" dh_auto_test -- --debug
 endif
